from netstatpy import *
from vulnscanpy import *
from datetime import datetime
import os
import pandas as pd

def ml():
    pcap_files = [
        # Good pcap
        {'name': 'Catture/good/chrome-48.0.2564.109_linux-4.17.0_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.43.199'},
        {'name': 'Catture/good/chrome-48.0.2564.109_windows10_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/chrome-68.0.3440.84_linux-4.17.0_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/chrome-68.0.3440.84_windows10_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/edge-42.17134.1.0_windows10_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/firefox-42.0_linux-4.17.0_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/firefox-42.0_windows10_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/firefox-62.0_linux-4.17.0_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},
        {'name': 'Catture/good/firefox-62.0_windows10_none.pcap',
            'evil': False, 'class': 'good', 'host_ip': '192.168.0.5'},

        # Evil pcap
        {'name': 'Catture/evil/linux-openvas-juiceshop-http.pcap',
            'evil': True,  'class': 'openvas', 'host_ip': '2.2.2.2'},
        {'name': 'Catture/evil/linux-openvas-juiceshop-scan.pcap',
            'evil': True,  'class': 'openvas', 'host_ip': '2.2.2.2'},
        {'name': 'Catture/evil/linux-sqlmap-dvwa-http.pcap',
            'evil': True, 'class': 'sqlmap', 'host_ip': '2.2.2.2'},
        {'name': 'Catture/evil/linux-wapiti-dvwa-http.pcap',
            'evil': True, 'class': 'wapiti', 'host_ip': '2.2.2.2'},
    ]

    res = pd.DataFrame()

    for pcap in pcap_files:
        friendly_name = pcap['name'].split("/")[2].split(".pcap")[0]
        output_filename = 'Analysis/scapy/' + friendly_name
        
        if os.path.exists(output_filename):
            stats  = LoadStats(output_filename)  # read file and load stats
        else:
            before = datetime.now()
            stats = Netstatpy(pcap['host_ip'], output_flag=True, output_file=output_filename, pcap=pcap['name'], training=True)
            after = datetime.now()
            with open(output_filename, 'a') as f:
                f.write("\n\n" + str(after - before))
        stats['evil'] = pcap['evil']
        stats['class'] = pcap['class']

        res = res.append(stats, ignore_index=True)
        
    before = datetime.now()
    # Vulnscanpy(res, binary='evil', save=False, training=True)
    Vulnscanpy(res, multiclass='class', save=False, training=True)
    after = datetime.now()
    print(after - before)

if __name__ == "__main__":
    ml()

