import argparse

# TODO - come argomento prendere una cartella di log
# Per ogni file input e inserire ip_host e classe (binaria o multi in base al flag)
# python -m vulnscanpy --multi -i Analysis --config config_file --deep --training
# config file continiene i pesi delle reti neurali e la RF trainata
# --deep usare NN altrimenti RF
# CTRL+C chiude l'analisi live (--live) e salva la configurazione in --export export_config se nulla e --config usa quello e la sovrascrive

def check_argument(DEBUG):
    parser = argparse.ArgumentParser(prog="python -m vulnscanpy", description='Vulnscanpy: Detect vulnerability scanning.')
    parser.add_argument('-c','--config', dest='config', help='configuration for the analysis.')
    parser.add_argument('-s','--save', action='store_true', help='create or replace config file after exit (CTRL+C).')
    parser.add_argument('-l','--live', action='store_true', help='get live data from stdin.')
    
    parser.add_argument('-M','--model', dest='model', help='force to use only one model for the analysis.')

    parser.add_argument('-b','--binary', dest='binary', help='column used for binary classification.')
    parser.add_argument('-m','--multiclass', dest='multiclass', help='column used for multiclass classification.')
    # Used only if vulnscanpy must be trained
    parser.add_argument('--training', dest="training", action='store_true', help=argparse.SUPPRESS)

    args = parser.parse_args()

    if not (args.binary or args.multiclass):
        parser.error('Select at least one option for the classification: -b and -m.')
        
    if DEBUG > 1:
        print(args)

    return args

def read_input():
    pass
