from vulnscanpy.models import *
import copy

# For configure models change the list below


def config_models(n_class, weight):
    """ List of all model involved in the analysis. """
    return [
        RF(class_weight="balanced", random_state=123456),
        NN(module__output_dim=n_class, weight=weight)  # device='cuda'
    ]

def learning(model, steps, params):
    """ Update steps of pipeline and the the params for the GridseachCV according to the model involed. """
    new_steps = copy.deepcopy(steps)
    new_params = copy.deepcopy(params)

    tag = model.get_tag_name()
    clf = (tag, model.get_model())

    model_params = model.get_my_params()
    if len(new_params) == 1 and len(model_params) == 1:
        new_params[0].update(model_params[0])
    elif len(new_params) == 1 and len(model_params) > 1:
        for model_param in model_params:
            model_param.update(new_params[0])
        else:
            new_params = model_params
    elif len(new_params) > 1 and len(model_params) == 1:
        for param in new_params:
            param.update(model_params[0])
    elif len(new_params) > 1 and len(model_params) > 1:
        for param in new_params:
            for model_param in model_params:
                param.update(model_param)
    else:
        raise Exception("Params wrong")
        
    new_steps.append(clf)

    return new_steps, new_params
