import sys
from vulnscanpy.lib import check_argument, analysis

# 0: No debug
# 1: Print dataset shape, best score training and support of kbest
# 2: Print argument and list of models 
# 3: Print correlation matrix
DEBUG = 2

def main(dataset):
    global DEBUG
    args=check_argument(DEBUG)

    # TODO - se training creare modello altrimenti caricarne uno salvato e usarlo per classificare
    analysis(args, dataset, DEBUG)

    # Best: 0.998877 using {'kbest__k': 30, 'kbest__score_func': < function chi2 at 0x0000024A390636A8 >, 'rf__criterion': 'entropy', 'rf__max_depth': 8, 'rf__n_estimators': 500, 'scaler': MinMaxScaler(copy=True, feature_range=(0, 1))}
    # Best: 0.998666 using {'kbest__k': 20, 'kbest__score_func': <function mutual_info_classif at 0x000001C338F627B8>, 'rf__criterion': 'entropy', 'rf__max_depth': 8, 'rf__n_estimators': 500, 'scaler': Sta

# Wrapper for the import of the package
def Vulnscanpy(dataset, binary=None, multiclass=None, config_file=None, save=True, model=None, training=False):
    args = []

    if binary: args += ["-b", binary]
    if multiclass: args += ["-m", multiclass]
    if config_file: args += ["-c", config_file]
    if save:  args.append("-s")
    if model: args += ["-M", model]   
    if training: args.append("--training")
    if args: sys.argv = [sys.argv[0]] + args

    if "training" in args:
        return main(dataset)
    else:
        main(dataset)

# Launch MAIN
if __name__ == "__main__":
    # Implicit live analysis
    main(sys.stdin)
