""" 
    This is a dummy model with the basic function to create a compatible model for vulnscapy.
    Required:
        - Tag name and model in __init__
        - Implent method my_params() for GridSearchCV

    The goal of this type of class is to abstract all model and params selection in the vulnscapy workflow.
    Example of usage: RF.py or NN.py
"""

from abc import abstractmethod
class DummyModel():
    def __init__(self, tag_name, model):
        self.tag_name = tag_name
        self.model = model

    def get_tag_name(self):
        return self.tag_name

    def get_model(self):
        return self.model

    def get_my_params(self):
        tag_index = self.get_tag_name() + "__"
        
        new_params = []
        for param in self.my_params():
            tmp_param = {}
            for k,v in param.items():
                tmp_param[tag_index+k] = v
            new_params.append(tmp_param)
        return new_params

    @abstractmethod
    def my_params(self):
        """ This method is used to """
        pass
